﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
namespace RazorDemo
{
    public abstract class TemplateBase : IDisposable
    {
        public TemplateBase()
        {
            this.Output = new StringWriter();
        }
        
        public dynamic Model { get; set; }
        public StringWriter Output { get; private set; }

        //写入变量
        public virtual void Write(object value)
        {
            this.WriteLiteral(value.ToString());
        }

        //写入固定字符串
        public virtual void WriteLiteral(string value)
        {
            this.Output.Write(value);
        }

        //入口函数
        public abstract void Execute();

        void IDisposable.Dispose()
        {
            this.Output.Dispose();
        }
    }
}
